#ifndef IZ_POOL_H
#define IZ_POOL_H

#include <SDL_stdinc.h>
#include "../IZ_common.h"

#define POOL_MAX_ITEMS (1000) // 16 million allocations max
#define POOL_MAX_SIZE (1l << 23) // 16MB

struct IZ_Pool;

typedef struct {
	void* pointer;
	size_t size;
	u64 created_at;
	struct IZ_Pool* pool;
} IZ_PoolItem;

typedef struct IZ_Pool {
	u16 top;
	u64 next_address;
	IZ_PoolItem items[POOL_MAX_ITEMS];
	void* memory;
} IZ_Pool;

void IZ_PoolInitialize(IZ_Pool*);

IZ_PoolItem* IZ_PoolAllocate(IZ_Pool*, size_t, u64);

void IZ_PoolDeallocate(IZ_PoolItem*);

void IZ_PoolTeardown(IZ_Pool*);

#endif
